HDU2795:Billboard(线段树单点更新)

来源:互联网 发布:衡阳软件培训 编辑:程序博客网 时间:2024/05/17 04:02
Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
 

Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
 

Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
 

Sample Input
3 5 524333
 

Sample Output
1213-1


 

题意:有个公告板,大小为h*w,要贴n张公告,每个公告的长度是k,高度固定为1,公告放的要尽可能靠上并尽可能靠左,每给出一张公告,要求这个公告在满足要求的情况下放在了第几层。

思路:按照线段树的做法的话,因为公告的高度固定为1,可以对公告板的高度进行线段花费,将其现在的宽度值存起来,然后每次遍历从左子树开始往下走,知道走到叶子节点满足要求即可

#include <stdio.h>#include <string.h>#include <algorithm>using namespace std;int h,w,n;int ans;struct node{    int l,r,n;} a[1000000];void init(int l,int r,int i,int w)//建树{    a[i].l=l;    a[i].r=r;    a[i].n=w;    if(l!=r)    {        int mid=(l+r)/2;        init(l,mid,2*i,w);        init(mid+1,r,2*i+1,w);    }}void insert(int i,int x){    if(a[i].l == a[i].r)//到了叶子节点,叶子节点的值既是层数    {        a[i].n-=x;//该层宽度减少        ans = a[i].l;        return ;    }    if(x<=a[2*i].n)//符合要求搜左子树        insert(2*i,x);    else//否则右子树        insert(2*i+1,x);    a[i].n = max(a[2*i].n,a[2*i+1].n);//将左右子树里能放的最大长度存入父亲节点,进行更新}int main(){    int i,k;    while(~scanf("%d%d%d",&h,&w,&n))    {       if(h>n)//根据题意,因为最多放n个公告,占用的最大高度也只有n,如果根据h的大小建树,由于h太大,这个树根本就建不起来,所以在这里就优化建树的高度            h = n;        init(1,h,1,w);        ans = -1;        for(i = 1; i<=n; i++)        {            scanf("%d",&k);            if(a[1].n>=k)//如果这个公告没有超出公告板的长度,那么才能放入                insert(1,k);            printf("%d\n",ans);            ans = -1;        }    }    return 0;}


 

 

原创粉丝点击